#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>
#include <pthread.h>

#include "unDriver.h"
#include "sensor.h"

#define DEVICENAME "/dev/myDevice0"
#define initVal1 -10
#define initVal2 -10
#define pseudoPeriod 1

static int devID0;
sensorMessage message1;
sensorMessage message2;

void * sendData(void * null)
{	
	int timeSent;		// instant d'envoi
	int i = 0;
	int sendM2 = 0;

	while (1)
	{
		sleep(pseudoPeriod);		

		message1.value += 10; // valeur capteur croissante
		if (message1.value > 120)
		{ message1.value = -10;}
		// envoi driver
		write(devID0,(char*)&message1,sizeof(sensorMessage));

		if (sendM2)
		{
		message2.value += 20; // valeur capteur croissante
		if (message2.value > 120)
		{ message2.value = -10;}
		// envoi driver
		write(devID0,(char*)&message2,sizeof(sensorMessage));
		sendM2=0;		
		}
		else
		{
		sendM2=1;
		}
		i++;
	
	}
	close(devID0);
	pthread_exit(NULL);
}

int main(void)
{

	pthread_t sendDataID;
	int cr;

	// mise a jour valeur initiale capteur
	message1.ad = adSensor1;
	message2.ad = adSensor2;
	message1.value = initVal1;
	message2.value = initVal2;

	devID0 = open(DEVICENAME,O_RDWR);
	printf("test Driver sur fd = %i\n", devID0);

	if (devID0>0)
	{

		// activation du thread emulant les capteurs
		cr = pthread_create(&sendDataID,NULL,sendData,NULL);

		if (cr==0)
		{
			printf("\nactivation capteurs ok\n");
		}
		else
		{
			printf("\npas d'activation des capteurs\n");
		}
	}
	else
	{
		printf("\nerreur sur l'ouverture du device\n");
	}
	
	pthread_exit(NULL);
}
