#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>

#include "unDriver.h"

#define DEVICENAME1 "/dev/myDevice1"
#define DEVICENAME2 "/dev/myDevice2"
#define MAX_THREADS_ACQ 2
#define pseudoPeriod 1

pthread_mutex_t mutexValeurs;
pthread_cond_t condValMoyenne;
int newValMoyenne;

int valMoyenne=-1;
int val1=-1;
int val2=-1;

void * pollSensor(void * num)
{	
	int numero = (int) num+1;

	sensorInfo *pRead = (sensorInfo*) malloc(sizeof(sensorInfo));
	int redBytes;
	int devID;

	if (numero==1) { devID=open(DEVICENAME1,O_RDONLY);}
	if (numero==2) { devID=open(DEVICENAME2,O_RDONLY);}	

	while (1)
	{
		sleep(pseudoPeriod*numero);		

		redBytes= read(devID,(char*)pRead,sizeof(sensorInfo));
		if (redBytes>0)
		{
		printf("lecture de S%i : (%i,%i)(N°%i) sur %i octets\n",numero,pRead->value,pRead->pollData,pRead->cpt,redBytes);
		}
		else
		{
		printf("pas de lecture de S%i : (%i)(N°%i)\n",numero,pRead->value,pRead->cpt,redBytes);
		}	

		pthread_mutex_lock(&mutexValeurs);
			if (numero==1)
			{
				if(redBytes>0) {val1=pRead->value;}
				else {val1=-1;}
			}			
			if (numero==2)
			{
				if(redBytes>0) {val2=pRead->value;}
				else {val2=-1;}
			}
			if ((val1==-1)&&(val2==-1))
			{
				valMoyenne = -1;
			}
			if ((val1==-1)&&(val2>0))
			{
				valMoyenne = val2;
			}			
			if ((val1>0)&&(val2==-1))
			{
				valMoyenne = val1;
			}			
			if ((val1>0)&&(val2>0))
			{
				valMoyenne = (val1=val2)/2;
				newValMoyenne=1;
				pthread_cond_signal(&condValMoyenne);
			}			
		pthread_mutex_unlock(&mutexValeurs);		
	}
	pthread_exit(NULL);
}

void * Print(void * null)
{	
	while (1)
	{
		sleep(pseudoPeriod);			

		pthread_mutex_lock(&mutexValeurs);
			while (!newValMoyenne)
			{pthread_cond_wait(&condValMoyenne,&mutexValeurs);}
			newValMoyenne=0;			
			printf("valMoyenne : %i\n",valMoyenne);			
		pthread_mutex_unlock(&mutexValeurs);
	}
	pthread_exit(NULL);
}


int main(void)
{

	pthread_t threadSensor[MAX_THREADS_ACQ];
	pthread_t threadAff;
	int cr;
	long threadNumber;

	pthread_mutex_init(&mutexValeurs,NULL);
	pthread_cond_init(&condValMoyenne,NULL);
	newValMoyenne = 0;

	// activation du thread emulant les capteurs
	for(threadNumber=0;threadNumber<MAX_THREADS_ACQ;threadNumber++)
	{	
		cr = pthread_create(&threadSensor[threadNumber],NULL,pollSensor,(void*)threadNumber);
	}
	
	cr = pthread_create(&threadAff,NULL,Print,NULL);

	pthread_exit(NULL);
}

